library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

entity xcvr is
generic (tDE :time := 5 ns; tDZ : time := 5 ns);
    port (
        a: inout STD_LOGIC;
        b: inout STD_LOGIC;
        dir: in STD_LOGIC;
        not_en: in STD_LOGIC
    );
end xcvr;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture xcvr_arch of xcvr is
begin

proc_ab: process (not_en,dir,a)
begin
if ((not_en='0') and (dir='1')) then
  b <= a after tDE;
else
  b <= 'Z' after tDZ;
end if;
end process proc_ab;

proc_ba: process (not_en,dir,b)
begin
if ((not_en='0') and (dir='0')) then
  a <= b after tDE;
else
  a <= 'Z' after tDZ;
end if;
end process proc_ba;

end xcvr_arch;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;


entity xcvrn is
generic ( size :integer := 32; tDE :time := 5 ns; tDZ : time := 5 ns);
    port (
        a: inout STD_LOGIC_VECTOR (size-1 downto 0);
        b: inout STD_LOGIC_VECTOR (size-1 downto 0);
        dir: in STD_LOGIC;
        not_en: in STD_LOGIC
    );
end xcvrn;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture xcvrn_arch of xcvrn is
-- Component instantiated by Turbo autoplace on 10/26/95 at 11:06:12
COMPONENT xcvr
generic (tDE :time := 5 ns; tDZ : time := 5 ns);
    port (
        a: inout STD_LOGIC;
        b: inout STD_LOGIC;
        dir: in STD_LOGIC;
        not_en: in STD_LOGIC
    );
END COMPONENT;
begin

c_call: FOR i IN 0 TO size-1 GENERATE
          bits: xcvr port map (a => a(i), b => b(i), not_en => not_en, dir => dir);
        END GENERATE;    
end xcvrN_arch;
